<?php

namespace App\Http\Controllers;

use App\Models\Formulario;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\Request;

class FormularioController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index(): JsonResponse
    {
        $items = Formulario::all();

        return response()->json([
            'success' => true,
            'data' => $items,
            'message' => 'Registros obtenidos correctamente',
        ], 200);
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(Request $request): JsonResponse
    {
        $payload = $request->only((new Formulario())->getFillable());
        $formulario = Formulario::create($payload);

        return response()->json([
            'success' => true,
            'data' => $formulario,
            'message' => 'Registro creado correctamente',
        ], 201);
    }

    /**
     * Display the specified resource.
     */
    public function show(Formulario $formulario): JsonResponse
    {
        return response()->json([
            'success' => true,
            'data' => $formulario,
            'message' => 'Registro obtenido correctamente',
        ], 200);
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(Request $request, Formulario $formulario): JsonResponse
    {
        $payload = $request->only((new Formulario())->getFillable());
        $formulario->update($payload);

        return response()->json([
            'success' => true,
            'data' => $formulario,
            'message' => 'Registro actualizado correctamente',
        ], 200);
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(Formulario $formulario): JsonResponse
    {
        $formulario->delete();

        return response()->json([
            'success' => true,
            'message' => 'Registro eliminado correctamente',
        ], 200);
    }
}